#include "io_win.h"
#include "extern.h"

IO_Window::IO_Window(PTWindowsObject AParent)
  : TWindow(AParent, "Output")
  {
//  outwin = this;
  screen = (char**)malloc(NUM_OF_RAW * sizeof(char*));
  for(int i = 0; i < NUM_OF_RAW; i++)
      {
      screen[i] = new char[NUM_OF_COL];
      screen[i][0] = '\0';
      }
  xpos = ypos = 0;
  start_x = start_y = 0;
  }
//////////////////////////////////////////
IO_Window::~IO_Window()
  {
//  outwin = NULL;
  for(int i = 0; i < NUM_OF_RAW; i++)
    delete screen[i];
  delete screen;
  }
////////////////////////////////////////////
void IO_Window::Paint(HDC dc, PAINTSTRUCT& PaintInfo)
  {
  RECT r;
  GetClientRect(HWindow, &r);

  TEXTMETRIC tm;
  GetTextMetrics(dc, &tm);
  int h = tm.tmHeight;
  int w = tm.tmAveCharWidth;
  int raws = (r.bottom - r.top + 1) / h;
  int rt = r.right - r.left + 1;

  start_y = ypos < raws ? 0 : ypos - raws;
  Rectangle(dc, r.left, r.top, r.right, r.bottom);
  for(int i = start_y; i < ypos; i++)
    TextOut(dc, 0, (i - start_y) * h, screen[i], strlen(screen[i]));
  }
//////////////////////////////////////////
int IO_Window::printf(double argument)
  {
  char s[NUM_OF_COL];
  sprintf(s, "%f", argument);
  show_text(s);
  return strlen(s);
  }
///////////
int IO_Window::printf(char * argument)
  {
  show_text(argument);
  return strlen(argument);
  }
////////////////////////////////////////////////////////
int IO_Window::printf(char * format, double argument)
  {
  char s[NUM_OF_COL];
  sprintf(s, format, argument);
  show_text(s);
  return strlen(s);
  }
///////////////////////////////////////////////////////////
void IO_Window::show_text(char* text)
  {
  HDC dc = GetDC(HWindow);
  RECT r;
  GetClientRect(HWindow, &r);

  TEXTMETRIC tm;
  GetTextMetrics(dc, &tm);
  int h = tm.tmHeight;
  int w = tm.tmAveCharWidth;
  int raws = (r.bottom - r.top + 1) / h - 1;
  int rt = r.right - r.left + 1;

  BOOL finished = FALSE;
    
  for(int i = 0; i < strlen(text) || i < NUM_OF_COL; i++)
    {
    finished = FALSE;
    if(ypos == NUM_OF_RAW)
      {
      finished = TRUE;
      Rectangle(dc, r.left, r.top, r.right, r.bottom);
      char* tmp = screen[0];
      for(int j = 0; j < ypos - 1; j++)
	screen[j] = screen[j + 1];
      screen[NUM_OF_RAW - 1] = tmp;
      screen[NUM_OF_RAW - 1][0] = '\0';

      for(j = start_y; j < NUM_OF_RAW; j++)
	TextOut(dc, 0, (j - start_y) * h, screen[j], strlen(screen[j]));
      start_x = xpos = 0;

      ypos--;
      }
    if(text[0] == '\n')
      {
      finished = TRUE;
      xpos = 0;
      start_x = 0;
      ypos++;
      break;
      }
    if(ypos - start_y >= raws)
      {
      Rectangle(dc, r.left, r.top, r.right, r.bottom);
      start_y++;
      start_x = xpos = 0;
      for(int j = start_y; j < NUM_OF_RAW; j++)
	TextOut(dc, 0, (j - start_y) * h, screen[j], strlen(screen[j]));
      }
    screen[ypos][xpos] = text[i];
    xpos++;
    }
  if(!finished)
    {
    screen[ypos][xpos] = '\0';
    TextOut(dc, start_x * w, (ypos - start_y) * h, screen[ypos] + start_x,
	xpos - start_x);
    }
  ReleaseDC(HWindow, dc);
  }
////////////////////////////////////////////////////////////
